
pub fn enc(m: u8, k: u32) -> u8 {
    todo!();
}

pub fn dec(c: u8, k: u32) -> u8 {
    todo!();
}

pub fn enc_ecb(m: &mut [u8], k: u32) {
    todo!();
}

pub fn dec_ecb(c: &mut [u8], k: u32) {
    todo!();
}

pub fn enc_cbc(m: &mut [u8], k: u32, iv: u8) {
    todo!();
}

pub fn dec_cbc(c: &mut [u8], k: u32, iv: u8) {
    todo!();
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_enc() {
        let k = 0x98267351;
        for x in 0..0xff {
            assert!(x == dec(enc(x, k), k));
        }
    }

    #[test]
    fn test_enc_ecb() {
        let k: u32 = 0x98267351;
        let m = b"sads";
        let c: [u8; 4] = [0xd3, 0xf2, 0xa0, 0xd3];
        let mut b = m.clone();
        enc_ecb(&mut b, k);
        assert!(b == c);
    }

    #[test]
    fn test_enc_ecb_roundtrip() {
        let k: u32 = 0x98267351;
        let m = b"this is a test";
        let mut b = m.clone();
        enc_ecb(&mut b, k);
        dec_ecb(&mut b, k);
        assert!(b == *m);
    }

    #[test]
    fn test_enc_cbc() {
        let k: u32 = 0x98267351;
        let iv: u8 = 0x42;
        let m = b"sads";
        let c: [u8; 4] = [0xd7, 0xad, 0x78, 0x74];
        let mut b = m.clone();
        enc_cbc(&mut b, k, iv);
        assert!(b == c);
    }

    #[test]
    fn test_enc_cbc_roundtrip() {
        let k: u32 = 0x98267351;
        let iv: u8 = 0x42;
        let m = b"this is a test";
        let mut b = m.clone();
        enc_cbc(&mut b, k, iv);
        dec_cbc(&mut b, k, iv);
        assert!(b == *m);
    }
}
